/*
 * ktrace.c
 *
 * ktrace bindings
 *
 * Author  : Hye-Shik Chang <perky@fallin.lv>
 * Date    : $Date: 2002/06/13 22:46:01 $
 * Created : 14 June 2002
 *
 * $Revision: 1.1 $
 */


/*
 * Constants Listing
 */
#if defined(PYFB_CONSTANTS)

SET_INTCONSTANT(KTROP_SET)
SET_INTCONSTANT(KTROP_CLEAR)
SET_INTCONSTANT(KTROP_CLEARFILE)
SET_INTCONSTANT(KTRFLAG_DESCEND)
SET_INTCONSTANT(KTRFAC_SYSCALL)
SET_INTCONSTANT(KTRFAC_SYSRET)
SET_INTCONSTANT(KTRFAC_NAMEI)
SET_INTCONSTANT(KTRFAC_GENIO)
SET_INTCONSTANT(KTRFAC_PSIG)
SET_INTCONSTANT(KTRFAC_CSW)
SET_INTCONSTANT(KTRFAC_INHERIT)


/*
 * Methods Listing
 */
#elif defined(PYFB_METHODS)

METHOD(ktrace),


/*
 * Function Bindings
 */
#else

#include <sys/ktrace.h>

static char Py_ktrace__doc__[] =
"ktrace(tracefile, ops, trpoints, pid): process tracing";

static PyObject *
Py_ktrace(PyObject *self, PyObject *args)
{
    char *tracefile;
    int ops, trpoints, pid;

    if (! PyArg_ParseTuple(args, "siii:ktrace", &tracefile, &ops, &trpoints, &pid))
        return NULL;

    if (ktrace(tracefile, ops, trpoints, pid) == -1) {
        PyErr_SetFromErrno(PyExc_OSError);
        return NULL;
    }

    Py_INCREF(Py_None);
    return Py_None;
}

#endif
