/*
 * reboot.c
 *
 * reboot bindings
 *
 * Author  : Hye-Shik Chang <perky@fallin.lv>
 * Date    : $Date: 2002/06/13 21:20:20 $
 * Created : 14 June 2002
 *
 * $Revision: 1.1 $
 */


/*
 * Constants Listing
 */
#if defined(PYFB_CONSTANTS)

SET_INTCONSTANT(RB_AUTOBOOT)
SET_INTCONSTANT(RB_ASKNAME)
SET_INTCONSTANT(RB_DFLTROOT)
SET_INTCONSTANT(RB_DUMP)
SET_INTCONSTANT(RB_HALT)
SET_INTCONSTANT(RB_POWEROFF)
SET_INTCONSTANT(RB_INITNAME)
SET_INTCONSTANT(RB_KDB)
SET_INTCONSTANT(RB_NOSYNC)
SET_INTCONSTANT(RB_RDONLY)
SET_INTCONSTANT(RB_SINGLE)


/*
 * Methods Listing
 */
#elif defined(PYFB_METHODS)

METHOD(reboot),


/*
 * Function Bindings
 */
#else

#include <sys/reboot.h>

static char Py_reboot__doc__[] =
"reboot([howto]): reboot system or halt processor";

static PyObject *
Py_reboot(PyObject *self, PyObject *args)
{
    int howto = RB_AUTOBOOT;

    if (! PyArg_ParseTuple(args, "|i:howto", &howto))
        return NULL;

    if (reboot(howto) == -1) {
        PyErr_SetFromErrno(PyExc_OSError);
        return NULL;
    }

    Py_INCREF(Py_None);
    return Py_None;
}

#endif
